package org.jcg.zheng;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class StringLiteralTest {
	@Test
	public void equalsOperator_and_equalsMthods_on_object_string() {
		// == operator compares two objects have the same object reference
		// equals and equals compare two object has the same content value

		String firstString = new String("Test");
		String secondString = new String("Test");

		assertTrue(firstString.equals(secondString));
		assertFalse(firstString == secondString);
	}

	@Test
	public void equalsOperator_and_equalsMthods_on_object_literal_string() {
		// Java internally provides String pool for the literal String,
		String firstString = "Test";
		String secondString = "Test";

		assertTrue(firstString == secondString);
		assertTrue(firstString.equals(secondString));
	}

	@Test
	public void test_null() {
		assertTrue(null == null);

		String testString = "Demo";
		assertFalse(testString.equals(null));

		assertFalse(testString.equalsIgnoreCase(null));

	}

}
